#! /bin/sh

TMP=/tmp/tei2html.env
#env > $TMP
#echo "ARGS: $*" >> $TMP

LANG=koi8-r; export LANG

echo "Content-type: text/html"
#TODO: charset?
#TODO: Content-length?
echo

cd /tmp
SGML_HOME=/usr/local/lib/TEItools; export SGML_HOME
USER=nobody; export USER
PATH=/usr/local/bin:${PATH}; export PATH
LD_LIBRARY_PATH=/usr/local/lib; export LD_LIBRARY_PATH
TEI2HTML=${SGML_HOME}/bin/tei2html
CACHE=/tmp/.tei-cache
CACHEDIR=${CACHE}/`dirname $1`
mkdir -p $CACHEDIR 
BASENAME=`basename $1 .tei`
HTMLNAME=${BASENAME}.html
cd $CACHEDIR
MAKEFILE=/tmp/tei2html.makefile
cat > $MAKEFILE <<EOF
.SUFFIXES: .tei .esis .html

${HTMLNAME}: $1
	-cp $1 .
	${TEI2HTML} ${BASENAME}.tei -style forced_toc -style toc_ref -style indent_para >/dev/null 2>&1
	-rm -f ${BASENAME}.esis ${BASENAME}.tei
EOF
/usr/bin/make -s -f $MAKEFILE 2>&1 >/dev/null
rm -f $MAKEFILE
cat $HTMLNAME
