#! /bin/sh

TMP=/tmp/tei2pdf.env
#env > $TMP
#echo "ARGS: $*" >> $TMP

LANG=koi8-r; export LANG

echo "Content-type: application/pdf"
#TODO: charset?
#TODO: Content-length?
echo

cd /tmp
SGML_HOME=/usr/local/lib/TEItools; export SGML_HOME
USER=nobody; export USER
PATH=/usr/local/bin:${PATH}; export PATH
LD_LIBRARY_PATH=/usr/local/lib; export LD_LIBRARY_PATH
TEI2TEX=${SGML_HOME}/bin/tei2tex
CACHE=/tmp/.tei-cache
CACHEDIR=${CACHE}/`dirname $1`
mkdir -p $CACHEDIR 
BASENAME=`basename $1 .tei`
PDFNAME=${BASENAME}.pdf
cd $CACHEDIR
MAKEFILE=/tmp/tei2pdf.makefile
cat > $MAKEFILE <<EOF
.SUFFIXES: .tei .esis .tex .pdf

${PDFNAME}: $1
	-cp $1 .
	${TEI2TEX} ${BASENAME}.tei -style ps_fonts -style pdf >/dev/null 2>&1
	pdflatex ${BASENAME}.tex
	-rm -f ${BASENAME}.esis ${BASENAME}.tei ${BASENAME}.tex ${BASENAME}.aux ${BASENAME}.toc
EOF
/usr/bin/make -s -f $MAKEFILE 2>&1 >/dev/null
rm -f $MAKEFILE
cat $PDFNAME
