#! /bin/sh -x

TMP=/tmp/tei2toc.env
env > $TMP
echo "ARGS: $*" >> $TMP

LANG=koi8-r; export LANG

echo "Content-type: text/html"
#TODO: charset?
#TODO: Content-length?
echo

cd /tmp
SGML_HOME=/usr/local/lib/TEItools; export SGML_HOME
USER=nobody; export USER
PATH=/usr/local/bin:${PATH}; export PATH
LD_LIBRARY_PATH=/usr/local/lib; export LD_LIBRARY_PATH
TEI2TOC=${SGML_HOME}/site/bin/tei2toc
CACHE=/tmp/.tei-cache
CACHEDIR=${CACHE}/`dirname $1`
mkdir -p $CACHEDIR 
BASENAME=`basename $1 .tei`
HTMLNAME=${BASENAME}.toc
cd $CACHEDIR
MAKEFILE=/tmp/tei2toc.makefile
cat > $MAKEFILE <<EOF
.SUFFIXES: .tei .esis .toc

${HTMLNAME}: $1
	-cp $1 .
	${TEI2TOC} ${BASENAME}.tei # >/dev/null 2>&1
	-rm -f ${BASENAME}.esis ${BASENAME}.tei
EOF
/usr/bin/make -s -f $MAKEFILE # 2>&1 >/dev/null
rm -f $MAKEFILE
cat $HTMLNAME
