#
# Simple.tcl --
#	Simple, one-pass translation module for Cost 2.
#
# $Revision: 1.4 $

global translateSpec 
set translateSpec "translate"

environment translateEnv  \
	cdataFilter identity  \
	sdataFilter identity

proc identity {text}	{ return $text }
proc output {text}	{ puts stdout $text nonewline }

eventHandler translateHandler -global {
    START {
#	Debug "Element: [query gi]"
	output [subst [$translateSpec get before ""]]
#	Debug "before done."
	translateEnv save
	foreach param {cdataFilter sdataFilter} {
	    if [$translateSpec has $param] {
		translateEnv set $param [$translateSpec get $param]
	    }
	}
#	Debug "filters set."
	$translateSpec do startAction
#	Debug "startAction done."
	output [subst [$translateSpec get prefix ""]]
#	Debug "prefix done."
    }
    END {
#	Debug "End of element: [query gi]"
	output [subst [$translateSpec get suffix ""]]
#	Debug "suffix done."
	$translateSpec do endAction
#	Debug "endAction done."
	translateEnv restore
	output [subst [$translateSpec get after ""]]
#	Debug "after done."
    }
    CDATA	{ output [[translateEnv get cdataFilter] [query content]] }
    RE  	{ output [[translateEnv get cdataFilter] "\n"] }
    SDATA	{ output [[translateEnv get sdataFilter] [query content]] }
    PI		{ $translateSpec do piAction }
}

proc main {} {
    catch {beforeTranslate}
    translateHandler
    catch {afterTranslate}
}
