<!-- Formal Public Identifier
-//Rick Geimer//DTD module for RTF elements 0.4//EN
-->

<!-- ============================================ -->
<!-- Rick's RTF Translation DTD	version 0.4       -->

<!-- Copyright (C) 1997-1998 Rick Geimer -->

<!-- This program is free software; you can redistribute it and/or -->
<!-- modify it under the terms of the GNU General Public Licence -->
<!-- as published by the Free Software Foundation; either version -->
<!-- 2 of the licence, or (at your option) any later version. -->

<!-- This program is distributed in the hope that it will be useful, -->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of -->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See  -->
<!-- the GNU General Public Licence for more details. -->

<!-- You should have received a copy of the GNU General Public Licence -->
<!-- along with this program; if not, write to the Free Software -->
<!-- Foundation, Inc., 675 Mass Ave, Cambridge, MA, 02139, USA. -->
<!-- The above licence is also available online at "http://www.gnu.org/". -->

<!-- Rick Geimer -->
<!-- rickg@sesha.com -->
<!-- 2401 Huran Drive -->
<!-- San Jose, CA, 95122 -->
<!-- USA -->
<!-- ============================================ -->

<!ENTITY % form.atts 
          			"	FONTNAME	CDATA	%default.val;
						FONTSIZE	CDATA	%default.val;			
						BOLD		CDATA	%default.val;			
						ITALIC		CDATA	%default.val;			
						UNDERLINE	CDATA	%default.val;					
						SUBSCRIPT	CDATA	%default.val;					
						SUPERSCRIPT	CDATA	%default.val;	
						CHARSET		CDATA	'0'"								> 										
<!ENTITY % inlines 
					"	#PCDATA | STRING | FIELD | SHPPICT | NONSHPPICT | ESCAPE | TAB | 
						LINE | PNTEXT | ANSICHAR | UNICHAR | BULLET | FIGDATA | FOOTNOTE" >
						
<!--
	Toggle the INCLUDE and IGNORE values below if you want to use SGML-style SDATA 
	entities instead of Unicode character references.
-->

<!ENTITY % xml-ents "INCLUDE"	>
<!ENTITY % sdata-ents "IGNORE"	>
					
<![%xml-ents;[

<!-- I had to use these values for NSGMLS, since it doesn't seem to like hex.
<!ENTITY rdquo "&#8221;" >
<!ENTITY ldquo "&#8220;" >
<!ENTITY bull "&#8226;" >
<!ENTITY rsquo "&#8217;" >
<!ENTITY lsquo "&#8216;" >
<!ENTITY mdash "&#8212;" >
<!ENTITY ndash "&#8211;" >
-->

<!ENTITY rdquo "&#x201D;" >
<!ENTITY ldquo "&#x201C;" >
<!ENTITY bull "&#x2022;" >
<!ENTITY rsquo "&#x2019;" >
<!ENTITY lsquo "&#x2018;" >
<!ENTITY mdash "&#x2014;" >
<!ENTITY ndash "&#x2013;" >

<!ENTITY tab "&#09;" >
<!ENTITY lt "<" >
<!ENTITY gt ">" >
<!ENTITY amp "&#38;" >
<!ENTITY nbsp "&#160;" >
<!ENTITY shy "&#173;" >
<!ENTITY line "&#10;" >		

]]>

<![%sdata-ents;[

<!ENTITY rdquo SDATA "[rdquo]" >
<!ENTITY ldquo SDATA "[ldquo]" >
<!ENTITY bull SDATA "[bull]" >
<!ENTITY rsquo SDATA "[rsquo]" >
<!ENTITY lsquo SDATA "[lsquo]" >
<!ENTITY mdash SDATA "[mdash]" >
<!ENTITY ndash SDATA "[ndash]" >
<!ENTITY tab SDATA "[tab]" >
<!ENTITY lt SDATA "[lt]" >
<!ENTITY gt SDATA "[gt]" >
<!ENTITY amp SDATA "[amp]" >
<!ENTITY nbsp SDATA "[nbsp]" >
<!ENTITY shy SDATA "[shy]" >
<!ENTITY line SDATA "[line]" >	

]]>

<!-- 
	The internal-escape entity is a hack to get around OmniMark's limited
	processing of character references. I prefix and suffix character 
	references with :_:_ in the find domain, then translate them back in
	the element domain. This means I must escape the literal string :_:_
	if it by chance shows up in the text of a document.
-->

<!ENTITY internal-escape ":_:_" >

<!ELEMENT FILE						( META?, SECTION+ ) 				>
<!ATTLIST FILE			CHARSET		CDATA		"ANSI"					>
<!ELEMENT META					( TITLE | AUTHOR | CREATION-DATE | 
									  TEMPLATE )* 						>
<!ELEMENT TITLE						( #PCDATA ) 						>
<!ELEMENT AUTHOR					( #PCDATA ) 						>
<!ELEMENT CREATION-DATE				( YEAR | MONTH | DAY | HOUR | 
									  MINUTE | SECOND )* 				>
<!ELEMENT YEAR						( #PCDATA ) 						>
<!ELEMENT MONTH						( #PCDATA ) 						>
<!ELEMENT DAY						( #PCDATA ) 						>
<!ELEMENT HOUR						( #PCDATA ) 						>
<!ELEMENT MINUTE					( #PCDATA ) 						>
<!ELEMENT SECOND					( #PCDATA ) 						>


<!ELEMENT TEMPLATE					( #PCDATA ) 						>
<!ELEMENT SECTION					( TABLE | P | FIELD | DOCLINK)+ 	>	
<!ELEMENT P						( %inlines; )* 						>
<!ATTLIST P				STYLENAME	CDATA		%default.val;
						ALIGN		CDATA		%default.val;
						%form.atts;										>
<!ELEMENT FOOTNOTE					( TABLE | P | FIELD | DOCLINK)+ 	>
<!ELEMENT FIELD						ANY									>
<!ELEMENT FLDINST					ANY									>
<!ELEMENT FLDRSLT					ANY									>
<!ELEMENT SHPPICT					ANY									>
<!ELEMENT NONSHPPICT				ANY									>
<!ELEMENT FIGURE 					EMPTY								>
<!ATTLIST FIGURE		
						FIGPATH		CDATA		#IMPLIED				
						XML:LINK	CDATA		#FIXED	"SIMPLE"
						HREF		CDATA		#REQUIRED				
						INLINE		(TRUE | FALSE)	'TRUE'				
						SHOW		(EMBED|REPLACE|NEW) "REPLACE"		>
<!ELEMENT FIGDATA 					EMPTY								>
<!ATTLIST FIGDATA		FILENAME	CDATA		#IMPLIED				>
<!ELEMENT SYMBOL 					EMPTY								>
<!ATTLIST SYMBOL		NUM			CDATA		#IMPLIED
						FONT		CDATA		#IMPLIED
						SIZE		CDATA		#IMPLIED				>
<!ELEMENT AUTODATE	 			EMPTY								>
<!ATTLIST AUTODATE		FORMAT		CDATA		#IMPLIED				>
<!ELEMENT PNTEXT					( %inlines; )*						>
<!ELEMENT STRING					( %inlines; )*						>
<!ATTLIST STRING		CHARSTYNAME	CDATA		%default.val;
						%form.atts;										>
<!ELEMENT DOCLINK 					EMPTY								>
<!ATTLIST DOCLINK		
						DOCPATH		CDATA		#IMPLIED				
						XML-LINK	CDATA		#FIXED	"SIMPLE"
						HREF		CDATA		#REQUIRED				
						INLINE		(TRUE | FALSE)	'TRUE'				
						SHOW		(EMBED|REPLACE|NEW) "REPLACE"		>
<!ELEMENT ANSICHAR					EMPTY								>
<!ATTLIST ANSICHAR		VALUE		CDATA		#IMPLIED				
						FONTNAME	CDATA		%default.val;				
						CHARSET		CDATA		%default.val;			>
<!ELEMENT UNICHAR					EMPTY								>
<!ATTLIST UNICHAR		VALUE		CDATA		#IMPLIED				
						ALT			CDATA		#IMPLIED				>
<!ELEMENT ESCAPE				EMPTY								>
<!ATTLIST ESCAPE		ENTVAL		CDATA		#IMPLIED				>
