# Common functions for HTML backends
# $Id: TEItoolsHTML.tcl,v 1.16 1999/11/17 13:59:24 tobotras Exp $

proc HtmlDTD {} {
     return "-//IETF//DTD HTML//EN"
}

proc HtmlHeader {} {
#    global TEItools_HtmlHeader_done
#    if { ![info exists TEItools_HtmlHeader_done] } {
#	set TEItools_HtmlHeader_done yes
	return "<!DOCTYPE HTML PUBLIC '[HtmlDTD]'>
<!-- Generated from TEI Lite DTD by TEItools.
  See http://xtalk.price.ru/SGML/TEItools
-->
<HTML><HEAD>
[UseCSS]
"
    } else {
	return
#    }
}

proc UseCSS {} {
    global TEItools_CSS_value
    if { [info exists TEItools_CSS_value] } {
	return "<Link Rel='Stylesheet' Type='text/css' Href='${TEItools_CSS_value}'>"
    }
    return
}

proc HtmlFooter {} {
    global TEItools_HtmlFooter_done
    if { ![info exists TEItools_Footer_done] } {
	set TEItools_HtmlFooter_done yes
	set fqdn {}
	global env
	if { [info exist env(HOST) ] } {
	    set fqdn $env(HOST)
	} elseif { [info exist env(HOSTNAME)] } {
	    set fqdn $env(HOSTNAME)
	} else {
	    catch {set fqdn [exec hostname]}
	}
	if { [string first "." $fqdn] == -1 } {
	    catch {set fqdn "${fqdn}.[exec domainname]"}
	}
	return "[TEItoolsSignature]
</BODY></HTML>
<!--
Converted to HTML by $env(USER)@$fqdn at [exec date]
-->
"
} else {
	return
}

}

proc TEItoolsSignature {} {
    return "<P class='aux'>[localize modified] [exec date]<BR>
<SMALL>
[localize producedby] <A HREF='http://xtalk.price.ru/SGML/TEItools/'>TEItools</A>
</SMALL>
"
}

substitution textFilterSdataSubst {
    {[AElig ]} {&AElig;}
    {[agrave]} {&agrave;}
    {[aacute]} {&aacute;}
    {[Aacute]} {&Aacute;}
    {[acirc ]} {&acirc;}
    {[Acirc ]} {&Acirc;}
    {[agrave]} {&agrave;}
    {[Agrave]} {&Agrave;}
    {[aring ]} {&aring;}
    {[Aring ]} {&Aring;}
    {[atilde]} {&atilde;}
    {[Atilde]} {&Atilde;}
    {[auml  ]} {&auml;}
    {[Auml  ]} {&Auml;}
    {[aelig ]} {&aelig;}
    {[AElig ]} {&AElig;}
    {[ccedil]} {&ccedil;}
    {[Ccedil]} {&Ccedil;}
    {[eth   ]} {&eth;}
    {[ETH   ]} {&ETH;}
    {[eacute]} {&eacute;}
    {[Eacute]} {&Eacute;}
    {[ecirc ]} {&ecirc;}
    {[Ecirc ]} {&Ecirc;}
    {[egrave]} {&egrave;}
    {[Egrave]} {&Egrave;}
    {[euml  ]} {&euml;}
    {[Euml  ]} {&Euml;}
    {[iacute]} {&iacute;}
    {[Iacute]} {&Iacute;}
    {[icirc ]} {&icirc;}
    {[Icirc ]} {&Icirc;}
    {[igrave]} {&igrave;}
    {[Igrave]} {&Igrave;}
    {[iuml  ]} {&iuml;}
    {[Iuml  ]} {&Iuml;}
    {[ntilde]} {&ntilde;}
    {[Ntilde]} {&Ntilde;}
    {[oacute]} {&oacute;}
    {[Oacute]} {&Oacute;}
    {[ocirc ]} {&ocirc;}
    {[Ocirc ]} {&Ocirc;}
    {[ograve]} {&ograve;}
    {[Ograve]} {&Ograve;}
    {[oslash]} {&oslash;}
    {[Oslash]} {&Oslash;}
    {[otilde]} {&otilde;}
    {[Otilde]} {&Otilde;}
    {[ouml  ]} {&ouml;}
    {[Ouml  ]} {&Ouml;}
    {[szlig ]} {&szlig;}
    {[thorn ]} {&thorn;}
    {[THORN ]} {&THORN;}
    {[uacute]} {&uacute;}
    {[Uacute]} {&Uacute;}
    {[ucirc ]} {&ucirc;}
    {[Ucirc ]} {&Ucirc;}
    {[ugrave]} {&ugrave;}
    {[Ugrave]} {&Ugrave;}
    {[uuml  ]} {&uuml;}
    {[Uuml  ]} {&Uuml;}
    {[yacute]} {&yacute;}
    {[Yacute]} {&Yacute;}
    {[yuml  ]} {&yuml;}
    {[amp   ]} {&amp;}
    {[lt    ]} {&lt;}
    {[gt    ]} {&gt;}
    {[copy  ]} {&copy;}
    {[mdash ]} {&nbsp;-- }
    {[ndash ]} {-}
    {[nbsp  ]} {&nbsp;}
    {[plusmn]} {&plusmn;}
    {[reg   ]} {&reg;}
    {[check ]} {X}
    {[hellip]} {...}
    {[deg   ]} {}
    {[percnt]} {%}
    {[numero]} {N}
    {[num   ]} {N}
    {[ordm  ]} {&ordm;}
    {[lsqb  ]} {[}
    {[rsqb  ]} {]}
    {[hyphen]} {-}
    {[latex ]} {L<BIG><SUB>A</SUB></BIG>T<BIG><SUB>E</SUB></BIG>X}
    {[tex   ]} {T<BIG><SUB>E</SUB></BIG>X}
    {[sharp ]} {#}
	{[le    ]} {<FONT FACE="Symbol"></FONT>}
	{[ge    ]} {<FONT FACE="Symbol"></FONT>}
	{[infin ]} {<FONT FACE="Symbol"></FONT>}
	{[permil]} {<FONT SIZE=-"2">o/oo</FONT>}
	{[part  ]} {<FONT FACE="Symbol">d</FONT>}

	{[agr   ]} {<FONT FACE="Symbol">a</FONT>}
	{[bgr   ]} {<FONT FACE="Symbol">b</FONT>}
	{[khgr  ]} {<FONT FACE="Symbol">c</FONT>}
	{[dgr   ]} {<FONT FACE="Symbol">d</FONT>}
	{[egr   ]} {<FONT FACE="Symbol">e</FONT>}
	{[phgr  ]} {<FONT FACE="Symbol">f</FONT>}
	{[ggr   ]} {<FONT FACE="Symbol">g</FONT>}
	{[eegr  ]} {<FONT FACE="Symbol">h</FONT>}
	{[igr   ]} {<FONT FACE="Symbol">i</FONT>}
	{[kgr   ]} {<FONT FACE="Symbol">k</FONT>}
	{[lgr   ]} {<FONT FACE="Symbol">l</FONT>}
	{[mgr   ]} {<FONT FACE="Symbol">m</FONT>}
	{[ngr   ]} {<FONT FACE="Symbol">n</FONT>}
	{[ogr   ]} {<FONT FACE="Symbol">o</FONT>}
	{[pgr   ]} {<FONT FACE="Symbol">p</FONT>}
	{[thgr  ]} {<FONT FACE="Symbol">q</FONT>}
	{[rgr   ]} {<FONT FACE="Symbol">r</FONT>}
	{[sgr   ]} {<FONT FACE="Symbol">s</FONT>}
	{[sfgr  ]} {<FONT FACE="Symbol">V</FONT>}
	{[tgr   ]} {<FONT FACE="Symbol">t</FONT>}
	{[ugr   ]} {<FONT FACE="Symbol">u</FONT>}
	{[ohgr  ]} {<FONT FACE="Symbol">w</FONT>}
	{[xgr   ]} {<FONT FACE="Symbol">x</FONT>}
	{[psgr  ]} {<FONT FACE="Symbol">y</FONT>}
	{[zgr   ]} {<FONT FACE="Symbol">z</FONT>}

	{[Agr   ]} {<FONT FACE="Symbol">A</FONT>}
	{[Bgr   ]} {<FONT FACE="Symbol">B</FONT>}
	{[KHgr  ]} {<FONT FACE="Symbol">C</FONT>}
	{[Dgr   ]} {<FONT FACE="Symbol">D</FONT>}
	{[Egr   ]} {<FONT FACE="Symbol">E</FONT>}
	{[PHgr  ]} {<FONT FACE="Symbol">F</FONT>}
	{[Ggr   ]} {<FONT FACE="Symbol">G</FONT>}
	{[EEgr  ]} {<FONT FACE="Symbol">H</FONT>}
	{[Igr   ]} {<FONT FACE="Symbol">I</FONT>}
	{[Kgr   ]} {<FONT FACE="Symbol">K</FONT>}
	{[Lgr   ]} {<FONT FACE="Symbol">L</FONT>}
	{[Mgr   ]} {<FONT FACE="Symbol">M</FONT>}
	{[Ngr   ]} {<FONT FACE="Symbol">N</FONT>}
	{[Ogr   ]} {<FONT FACE="Symbol">O</FONT>}
	{[Pgr   ]} {<FONT FACE="Symbol">P</FONT>}
	{[THgr  ]} {<FONT FACE="Symbol">Q</FONT>}
	{[Rgr   ]} {<FONT FACE="Symbol">R</FONT>}
	{[Sgr   ]} {<FONT FACE="Symbol">S</FONT>}
	{[Tgr   ]} {<FONT FACE="Symbol">T</FONT>}
	{[Ugr   ]} {<FONT FACE="Symbol">U</FONT>}
	{[OHgr  ]} {<FONT FACE="Symbol">W</FONT>}
	{[Xgr   ]} {<FONT FACE="Symbol">X</FONT>}
	{[PSgr  ]} {<FONT FACE="Symbol">Y</FONT>}
	{[Zgr   ]} {<FONT FACE="Symbol">Z</FONT>}


	{[aacgr ]}  {<FONT FACE="Symbol">a</FONT>}
	{[eacgr ]}  {<FONT FACE="Symbol">e</FONT>}
	{[eeacgr]}  {<FONT FACE="Symbol">h</FONT>}
	{[iacgr ]}  {<FONT FACE="Symbol">i</FONT>}
	{[oacgr ]}  {<FONT FACE="Symbol">o</FONT>}
	{[uacgr ]}  {<FONT FACE="Symbol">u</FONT>}
	{[ohacgr]}  {<FONT FACE="Symbol">w</FONT>}


	{[middot]} {}
	{[quot  ]} {"}
	{[lsquo ]} {'}
	{[rsquo ]} {'}
	{[ldquo ]} {``}
	{[rdquo ]} {''}

    }

proc textSdataFilter { text } {
    #These can't be done via second substitute. Ain't Tcl syntax exciting?
    regsub -all -- {\[laquo \]} $text [leftQuote] text1
    regsub -all -- {\[raquo \]} $text1 [rightQuote] text
    return [textFilterSdataSubst $text]
}

substitution textCdataSubst {
    {<} {&lt;}
    {&} {&amp;}
}

substitution verbatimCdataFilter {
    {<} {&lt;}
    { } {&nbsp;}
    {&} {&amp;}
}

proc textCdataFilter { text } {
    return [textCdataSubst $text]
}

proc leftQuote {} {
    return "\""
}

proc rightQuote {} {
    return "\""
}

proc verbatimCdataFilter { text } {
    regsub -all -- {<} $text {\&lt;} text
    return $text
}

proc elt { gi } {
    global TEItools_CSS_value
    set class [query gi]
    if { [info exist TEItools_CSS_value] && "$class" != "" } {
	return "$gi class='$class'"
    }
    return $gi
}

proc graphicFileName { filename } {
    foreach realName "$filename ${filename}.gif ${filename}.GIF ${filename}.jpeg ${filename}.JPEG ${filename}.jpg ${filename}.JPG" {
	if { [file readable $realName] } {
	    return $realName
	}
    }
    set filename [cutGraphicExtensionOff $filename]
    foreach realName "$filename ${filename}.gif ${filename}.GIF ${filename}.jpeg ${filename}.JPEG ${filename}.jpg ${filename}.JPG" {
	if { [file readable $realName] } {
	    return $realName
	}
    }
    puts stderr "***WARNING: No such file: $filename\n"
    return
}
