# $Id: locale.fi.tcl,v 1.19 1999/04/16 12:06:05 tobotras Exp $

#To be translated: index, abstract, man*, endNotes

substitution localize {
    {prev} {Edellinen}
    {next} {Seuraava}
    {abstract} {Abstract}
    {contents} {Sislt}
    {thebibliography} {Kirjallisuusluettelo}
    {appendices} {Liitteet}
    {LaTeX_preamble} {
	\ifx\undefined\cyr\def\cyr{}\fi
        \usepackage[english,finnish]{babel}
	\usepackage[latin1]{inputenc}
    }
    {pageBreak} {sivunvaihto}
    {cyr} {\cyr }
    {endhead} {\dots jatkoa}
    {endfoot} {Jatkuu}
    {continue_caption} {(jatkoa)}
    {lq} {``}
    {rq} {''}
    {producedby} {Asiakirjan tuottanut}
    {modified} {Viimeeksi muokattu:}
    {texMdash} {---}
    {rtfMdash} {$rtfSpecial(mdash)}
    {Heading} {Otsikko}
    {TOC} {Sisllysluettelo}
    {index} {Index}
    {manName} {NAME}
    {manSynopsis} {SYNOPSIS}
    {manDescription} {DESCRIPTIONS}
    {manBugs} {BUGS}
    {manNotes} {NOTES}
    {manOptions} {OPTIONS}
    {endNotes} {Notes}
    {noteHead} {Note:}
    {listoftables} {List of tables}
    {listoffigures} {List of figures}
}

# RTF only

proc tabTitle { number } {
    return "Taulukko ${number}:"
}

proc figTitle { number } {
    return "Kaavio ${number}:"
}

proc appendixPrefix { number } {
    return [appendixLetter $number]
}

proc appendixLetter { number } {
    return [string index "ABCDEFGHIJKLMNOPQRSTUVWXYZ" [expr $number - 1]]
}

proc listLetter { number } {
    return [string index "abcdefghijklmnopqrstuvwxyz" [expr $number - 1]]
}

# LaTeX only

proc openLang { language } {
    return
}

proc closeLang {} {
    return
}

# HTML only

proc SeeTocAndText { tocURL bodyURL } {
	return "

	Voit selata <a href='${tocURL}'>sisllysluetteloa</a> tai 
	<a href='${bodyURL}'>koko asiakirjaa</a>.
"
}

# SGML only

proc localeDivName { gi } {
    switch -regexp $gi {
	"(DIV)|(DIV[01])" {
	    return "luku"
	}
	"DIV2" {
	    return "kappale"
	}
	"DIV3" {
	    return "momentti"
	}
	default {
	    return ""
	}
    }
}
