# $Id: stylesheet.tcl,v 1.1 1999/10/29 10:10:50 tobotras Exp $

puts -nonewline stderr "Loading stylesheet..."

rtf:documentFormat {
    TopMargin		0.5in
    BottomMargin	0.5in
    FootnoteNumbering	Arabic
    FootnoteRestart	AtPage
    FootnotePlacement	PageBottom
}

# ------------------ rules

# -------------------- sections

rtf:sectStyle style_Slide "Slide" {
    LeftMargin		1cm
    RightMargin		1cm
    SectionBreak	None
}

# -------------------- paragraphs

rtf:paraStyle style_Default "Default" {
    FontSize 12pt
    Font roman
    SpaceBefore 6pt
    LeftIndent 0pt
    FirstIndent 0mm
    LineSpacing 18pt
    Quadding Justify
}

rtf:paraStyle default "Normal" -basedon style_Default {
}

rtf:paraStyle style_Title "Presentation title" -basedon style_Default {
    FontSize 24pt
    Bold 1
    Quadding Center
}

rtf:paraStyle style_Author "Presentation author" -basedon style_Default {
    FontSize 18pt
    Bold 1
    Font sans
    Quadding Center
}

rtf:paraStyle style_Head "Slide title" -basedon style_Default {
    FontSize 16pt
    Font sans
    Bold 1
    Quadding Center
}

rtf:paraStyle style_List_Item "List item" -basedon style_Default {
    SpaceBefore 0pt
    LeftIndent 10mm
}

# ---------------------------- char styles

rtf:charStyle style_Plain "Default" {
    FontSize 10pt
}

rtf:charStyle style_Emphasis "Emphasis" -basedon style_Plain {
    FontSize 10pt
    Italic 1
}

# ----------------------------

puts stderr "done."
